/* eslint-disable jsx-a11y/iframe-has-title */
/* eslint-disable jsx-a11y/alt-text */
import React, { useState } from "react";
import { Formik } from "formik";
import * as Yup from "yup";
import axios from "axios";
import Alert from "@material-ui/lab/Alert";

const validationSchema = Yup.object({
  plantIndex: Yup.number()
    .min(0, "Minimum plant index atleast 0")
    .max(14, "Allowed maximum plant index is 14")
    .required("plantIndex  is required"),
});

const Dashboard = () => {
  const [isAdded, setIsAdded] = useState(false);
  const [showResults, setShowResults] = React.useState(false);
  const show = () => setShowResults(true);
  const hide = () => setShowResults(false);

  const Results = () => (
    <div>
      <img
        src="http://192.168.1.3:8007/stream.mjpg"
        width="90%"
        height="50%"
        className="rounded-lg ml-10"
      />
    </div>
  );

  const enterIndex = async (values) => {
    try {
      const response = await axios.get(
        `http://192.168.1.3:8080/navigate/manual/${values.plantIndex}`
      );
      setIsAdded(true);
      console.log(response);
    } catch (error) {
      console.log(error);
    }
  };

  const DefaultIndex = async (values) => {
    try {
      const response = await axios.get(
        `http://192.168.1.3:8080/navigate/manual/${0}`
      );
      setIsAdded(true);
      console.log(response);
    } catch (error) {
      console.log(error);
    }
  };
  return (
    <div className="grid grid-cols-3 gap-4 px-10 py-10">
      <div className="bg-white shadow-lg ">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=8"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=12"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=14"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=4"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=20"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=2"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=10"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=16"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=18"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=6"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">
        <iframe
          src="https://grafana.agroengine.cf/d-solo/FIVfVDDVk/agroengine-dashboard?orgId=1&refresh=5s&theme=light&panelId=22"
          width="100%"
          height="250px"
          className="rounded-lg"
          frameborder="0"
        ></iframe>
      </div>
      <div className="bg-white shadow-lg rounded-lg">12</div>
      <div className="col-span-2 bg-white shadow-lg rounded-lg">13</div>
      <div className="col-span-3 bg-white shadow-lg rounded-lg">
        <h1 className="text-2xl text-center font-bold text-gray-800 pt-5 ">
          PLANT LIVE STREAMING
        </h1>
        <div className="grid grid-cols-3 gap-4 px-10 py-5">
          <div className="col-span-2 bg-white shadow-lg rounded-lg">
            {showResults ? <Results /> : null}
            {/* <img
              src="http://192.168.1.3:8007/stream.mjpg"
              width="90%"
              height="50%"
              className="rounded-lg ml-10"
            /> */}
          </div>
          <div className="bg-white shadow-lg rounded-lg">
            <h1 className="text-xl text-center font-bold text-gray-800 pt-5 ">
              <Formik
                initialValues={{
                  plantIndex: "",
                }}
                validationSchema={validationSchema}
                onSubmit={async (values) => {
                  console.log(values);
                  enterIndex(values);
                }}
              >
                {({ handleChange, handleSubmit, values, errors, touched }) => (
                  <form
                    onSubmit={(event) => {
                      event.preventDefault();
                      handleSubmit();
                    }}
                  >
                    <div className="flex flex-col mb-2">
                      <div className=" flex-col-3 ">
                        <div className="col-span-2">
                          <label className="block text-sm font-medium leading-149 mb-3 md:text-lg">
                            Navigate to the plant index
                          </label>
                        </div>

                        <div className="">
                          <input
                            className={`focus:outline-none w-96 h-8 pl-3 border-2 rounded-lg focus:border-green-400 border-blue-600 ${
                              errors.plantIndex && touched.plantIndex
                                ? "border-red-500"
                                : "border-gray-600"
                            } text-base`}
                            id="plantIndex"
                            type="Number"
                            placeholder="Enter plant index"
                            onChange={handleChange("plantIndex")}
                            value={values.plantIndex}
                          />
                          {errors.plantIndex && touched.plantIndex ? (
                            <div className="text-red-500 text-xs mt-1 md:text-sm">
                              {errors.plantIndex}
                            </div>
                          ) : null}
                        </div>
                      </div>
                    </div>

                    {isAdded && (
                      <Alert severity="success">Successfully added</Alert>
                    )}

                    <div className="text-center mb-3 mt-4">
                      <button
                        type="submit"
                        className="bg-gradient-to-r from-blue-600 to-green-400 text-sm text-white font-bold py-2 px-6 rounded-lg"
                        style={{
                          boxShadow: "0px 10px 15px rgba(3, 17, 86, 0.25)",
                        }}
                      >
                        Navigate
                      </button>
                    </div>
                  </form>
                )}
              </Formik>
              <button
                type="submit"
                className="bg-gradient-to-r from-blue-600 to-purple-500 text-sm text-white font-bold py-2 px-6 rounded-lg"
                style={{
                  boxShadow: "0px 10px 15px rgba(3, 17, 86, 0.25)",
                }}
                onClick={() => DefaultIndex()}
              >
                Default Location
              </button>
              <button
                type="submit"
                className="bg-gradient-to-r from-blue-600 to-purple-500 text-sm text-white font-bold py-2 px-6 rounded-lg ml-2"
                style={{
                  boxShadow: "0px 10px 15px rgba(3, 17, 86, 0.25)",
                }}
                onClick={show}
              >
                Camera On
              </button>
              <button
                type="submit"
                className="bg-gradient-to-r from-blue-600 to-purple-500 text-sm text-white font-bold py-2 px-6 rounded-lg ml-2"
                style={{
                  boxShadow: "0px 10px 15px rgba(3, 17, 86, 0.25)",
                }}
                onClick={hide}
              >
                Camera Off
              </button>
            </h1>
          </div>
        </div>
      </div>
    </div>
  );
};

export default Dashboard;
